// fragment shader for dof

#version 430 core

in vec2 texCoord;

layout (binding = 0) uniform sampler2D colTex;
layout (binding = 1) uniform sampler2D blurTex; // stores amount of blur
layout (binding = 2) uniform sampler2D gaussTex;

layout (location = 0) out vec4 color;

void main(){
	vec4 fullres = texture(colTex, texCoord);
	vec4 gaussed = texture(gaussTex, texCoord);
	float blur = texture(blurTex, texCoord).x;

	color = fullres + blur * (gaussed - fullres);
	return;
}