// fragment shader for depth cube map for shadow mapping

#version 430 core
in vec4 FragPos;

uniform vec3 lightPos;
uniform float far_plane;
uniform bool useless3;
uniform bool useless4;

void main()
{
    // get distance between fragment and light source
    float lightDistance = length(FragPos.xyz - lightPos);
    
    // map to [0;1] range by dividing by far_plane
    lightDistance = lightDistance / far_plane;

    // Write this as modified depth
    gl_FragDepth = lightDistance;
}  