// fragment shader for dof

#version 430 core

layout (binding = 0) uniform sampler2D colTex;
layout (binding = 1) uniform sampler2D blurTex; // stores amount of blur
layout (binding = 2) uniform sampler2D depthTex;

uniform float zNear;
uniform float zFar;

uniform bool displayCol; // just for testing purposes, remove later

layout (location = 0) out vec4 color;

void main(){
	vec4 input_color = texelFetch(colTex, ivec2(gl_FragCoord.xy), 0).rgba;
	
	

	
	// Later the depth texture is not used here
	// for now it is here to visualize the depth values

	// calculating depth value
	float depthBuffer = texelFetch(depthTex, ivec2(gl_FragCoord.xy), 0).x; // depth buffer value
    float depthNDC = 2.0 * depthBuffer - 1.0; // normalized device coordinates
    float depth = 2.0 * zNear * zFar / (zFar + zNear - depthNDC * (zFar - zNear)); // depth in eyespace
	float depthN = depth/zFar; // linearly normalized depth [0..1]
		
	
	if(displayCol)
		color = input_color;
	else {
		color = vec4(depthN, depthN, depthN, 1);
		
		float blur = texelFetch(blurTex, ivec2(gl_FragCoord.xy), 0).x; 

		color = vec4(blur, 0, 0, 1);
		//color = vec4(depthN, 0, 1, 1);
	}
}